'Egy BASIC mintaprogram a PICPLC1 panelre.
'Az A0 analog bemenet beolvassa, egy 8 bites adatknt eltrolja, az eredmnyt kiirja az LCD-re
'A relt pedig az eredmnytl fggen kapcsolgatja.

' Konfigurljuk a PORTA-t. Teht hogy melyik kivezetseket akarjuk digitlis, vagy 
' analg portnak hasznlni, mi legyen a mrs referencia feszltsge. 
' Ezeket az ANSELA-B-C-D, az ADCON0 s ADCON1 regiszterbe tlttt adat fogja meghatrozni. 
' Szval, ha azt akarjuk, hogy a PORTA.0-1-3 mint analog,
' a PORTA.2-4-5 mint digitlis port legyen hasznlva, a
' a mrs referencia feszltsge pedig a tpfesz legyen, akkor:

' Akr 14 lb hasznlhat analg bemenetnek, de most minden lbat digitlis portnak akarunk.
   ANSELA = %00001111    ' porta 0-3 analg, a 4-7 digitlis
   ANSELB = %00000000    ' portb mind digitlis
   ANSELD = %00000000    ' portd mind digitlis
   ANSELE = %00000000    ' porte mind digitlis
   
	ADCON0 = %00000000	' Az ADC0, ADC ON regiszter 
'Balra igaztva az eredmny, Fosc/4 az A/D rajel, az ADref- a VSS, ADref+ a VCC :
	ADCON1 = %01000000	' Az ADref- a VSS, ADref+ a VCC  

'Kzljk a programmal, hol tallja az LCD-t, es hogyan akarjuk vezrelni:
 
	DEFINE LCD_DREG 	PORTD	' Az LCD adatvezetket a D portrol vezreljk
	DEFINE LCD_DBIT 	0	' Az els adatvezetk az RD port 0. tagja. (Az RD0)
	DEFINE LCD_RSREG 	PORTD	' Az LCD Register Select kivezetse a D portra csatlakozik,
	DEFINE LCD_RSBIT 	4	' mgpedig az RD4 labra. (Tehat az LCD RS - az RD4 porton van.)
	DEFINE LCD_EREG 	PORTD	' Az enable vezerl bit is a D porton,
	DEFINE LCD_EBIT 	5	' az RD5 portra van kiosztva. (LCD EN - RD5 port.)
	DEFINE LCD_BITS 	4	' a 4 bites uzemmodot vlasztjuk,
	DEFINE LCD_LINES 	2	' es 2 soros az LCD

	TRISA = %00001111	' A PORTA0-3 bemenet, a PORTA 4-7 kimenet legyen
	TRISB = %00000000	' A PORTB0-7 output

	RELE var PORTA.5			' A rel a PORTA 5-n vezrlve,
    PIROSLED var PORTB.7        ' A ktszn LED piros
	ZOLDLED var PORTB.6         ' A ktszn LED zld



	' Helyet foglalunk a vltozoknak a mikrokontroller RAM-jaban
	ANAL0 var byte		' Az ANAL0-ba kerl majd az RA0-on porton,
	
main:	ADCIN 0, ANAL0			' Beolvassuk az AN0 bemenetet az ANAL0 vltozoba
	
	LCDOUT $fe,1,"Analog= ",#ANAL0	' LCD trles, es irs az els sorba
		
	IF ANAL0 >= 100 Then
		HIGH RELE ' Ha ANAL0 100-nl nagyobb, a rel bekapcsol 
	ENDIF

	IF ANAL0 <= 80 Then
		LOW RELE 	' Ha 80 al megy. a rel kikapcsol
	ENDIF
	
	TOGGLE PIROSLED	' a ktszn LED piros felnek ki/bekapcsolgatsa (Mukodesjelzes)
			
	PAUSE 500		' 500 msec, azaz fl masodperc pause
	GOTO main		' Ugras a ciklus elejere, kezdodik minden ujra... 
	END				' Itt a progi vege. Ha tekergetjuk a potit, ltjuk az
					' eredmenyt az LCD-n, s kapcsolnak a relk
