'Egy BASIC mintaprogram a PICPLC1/8/16 panelre.  16F1937 mikrokontroller.
'Egy PCF8574-en alapul I2C LCD kezelse

' PCF8574 - LCD
'    bit7 = B/L LED (0=on; 1=off)
'    bit6 = RS (Register Select)
'    bit5 = R/W (Read/Write)
'    bit4 = E (Enable)
'    bit3 = DB7 data
'    bit2 = DB6 data
'    bit1 = DB5 data
'    bit0 = DB4 data

'Config - fuse bit - bellts
'A proci beptett rajelgenertort hasznlom - INTOSC - s kdvdelem - CP - kikapcsolva
'A PLL rajel ngyszerez, s az alacsonyfeszltsg programozs - LVP - kikapcsolva. 
#CONFIG             
    __config _CONFIG1, _FOSC_INTOSC & _CP_OFF
    __config _CONFIG2, _PLLEN_OFF & _LVP_OFF 
#endCONFIG

    OSCCON = %01101010   ' Belltom 4 megra a bels rajelet

    DEFINE I2C_SLOW 1 

' Akr 14 lb hasznlhat analg bemenetnek, de most minden lbat digitlis portnak akarunk.
   ANSELA = %00001111    ' porta 0-3 analg, a 4-7 digitlis
   ANSELB = %00000000    ' portb mind digitlis
   ANSELD = %00000000    ' portd mind digitlis
   ANSELE = %00000000    ' porte mind digitlis

   TRISC = %00111100	' A PORTC 2-5 input, a PORTC 0-1 s 6-7 output
   TRISA = %00000000	' A PORTA 0-7  output

'Elszr is kzljk a programmal, hol tallja az LCD-t, es hogyan akarjuk vezrelni:
 
	DEFINE LCD_DREG 	PORTD ' Az LCD adatvezetket a D portrol vezreljk
	DEFINE LCD_DBIT 	0	' Az els adatvezetk az RD port 0. tagja. (Az RD0)
	DEFINE LCD_RSREG 	PORTD ' Az LCD Register Select kivezetse a D portra csatlakozik,
	DEFINE LCD_RSBIT 	4	' mgpedig az RD4 labra. (Tehat az LCD RS - az RD4 porton van.)
	DEFINE LCD_EREG 	PORTD ' Az enable vezerl bit is a D porton,
	DEFINE LCD_EBIT 	5	' az RD5 portra van kiosztva. (LCD EN - RD5 port.)
	DEFINE LCD_BITS 	4	' a 4 bites uzemmodot vlasztjuk,
	DEFINE LCD_LINES 	4   ' es 4soros az LCD

	SCL Var PORTC.6  ' Clock pin
    SDA Var PORTC.7  ' Data pin
    LED2 var PORTA.4
   	PIROSLED var PORTB.7
	ZOLDLED var PORTB.6

    
ADDR CON 78    ' Az I2C modul cme !

LCD_Data        VAR BYTE        ' Az LCD-re kldend adat
LCD_Byte        VAR BYTE        ' Az I2C-n kldtt 4 adat, s a 4 vezrlbit
LCD_RS          VAR LCD_Byte.0  ; Register Select bit
LCD_RW          VAR LCD_Byte.1  ; Read/Write bit
LCD_E           VAR LCD_Byte.2  ; Enable bit
LCD_BackLight   VAR LCD_Byte.3  ; Backlight 1=ON
LCD_Byte2       VAR BYTE        ; Same nibble without E bit
LCD_Idx         VAR BYTE
testmode        var byte
index           var byte
szoveg          var byte(20)
	
    ' I2C LCD inicializls 
PAUSE 250             ; Adunk egy kis idt az LCD-nek, hogy felledjen

 ' Hromszor ki kell kldeni a 0011 - 3 - kdot az LCD DB7, DB6, DB5, DB4 lbaira
LCD_RW = 0            ' rni akarunk, RW lb alacsony legyen
LCD_BackLight = 1     ' Httrvilgts be
LCD_RS = 0            ' Utastst kldnk, az RS lb alacsony legyen
LCD_Data = $03        ' Teht a 0011 - 3 - hromszor :
gosub I2C_LCD_iras
PAUSE 10
gosub I2C_LCD_iras
PAUSE 10
gosub I2C_LCD_iras
PAUSE 10

LCD_Data = $02        ' 0010 kd : 4-bites zemmd
gosub I2C_LCD_iras
PAUSE 1

LCD_Data = $28        ' 28 parancs: 4 bites zemmd, 2 soros,                         
gosub I2C_LCD_iras      ' 5x8 pontos karakterek  
LCD_Data = $0C        ' 0C parancs: kperny bekapcsols
gosub I2C_LCD_iras      
LCD_Data = $01        ' 01 parancs: kperny trls
gosub I2C_LCD_iras      
PAUSE 2
LCD_Data = $06 
gosub I2C_LCD_iras     ' Entry Mode                      
PAUSE 2               


Main:
       ' Els sor:
ARRAYWRITE szoveg,["I","2","C"," ","L","C","D","M","o","d","u","l"," ","P","C","F","8","5","7","4"]       
    LCD_RS = 0   ' parancs kd
    LCD_Data = $FE
        gosub I2C_LCD_iras 
    LCD_Data = $80   'Az els sor elejre lltjuk a kurzort
        gosub I2C_LCD_iras 
   
    LCD_RS = 1   ' adat kd
  
    FOR index = 0 TO 19 'Loop 20 times
        LCD_Data  = szoveg[index]
        gosub I2C_LCD_iras
    NEXT index 'Loop again
    
       ' Msodik sor:
ARRAYWRITE szoveg,["*","*","*","*"," ","M","i","k","r","o","k","l","u","b"," ","*","*","*","*","*"]       
    LCD_RS = 0   ' parancs kd
    LCD_Data = $FE
        gosub I2C_LCD_iras 
    LCD_Data = $c0   'A harmadik sor elejre lltjuk a kurzort
        gosub I2C_LCD_iras 
   
    LCD_RS = 1   ' adat kd
  
    FOR index = 0 TO 19 'Loop 20 times
        LCD_Data  = szoveg[index]
        gosub I2C_LCD_iras
    NEXT index 'Loop again    


       ' Harmadik sor:
ARRAYWRITE szoveg,["*","*","*","*","*","*"," ","P","I","C","P","L","C","1"," ","*","*","*","*","*"]       
    LCD_RS = 0   ' parancs kd
    LCD_Data = $FE
        gosub I2C_LCD_iras 
    LCD_Data = $94   'A harmadik sor elejre lltjuk a kurzort
        gosub I2C_LCD_iras 
   
    LCD_RS = 1   ' adat kd
  
    FOR index = 0 TO 19 'Loop 20 times
        LCD_Data  = szoveg[index]
        gosub I2C_LCD_iras
    NEXT index 'Loop again
        


       ' Negyedik sor:
ARRAYWRITE szoveg,[" "," ","W","W","W",".","M","I","K","R","O","K","L","U","B",".","H","U"," "," "]
    LCD_RS = 0   ' parancs kd
    LCD_Data = $FE
        gosub I2C_LCD_iras 
    LCD_Data = $d4   'A harmadik sor elejre lltjuk a kurzort
        gosub I2C_LCD_iras 
   
    LCD_RS = 1   ' adat kd
  
    FOR index = 0 TO 19 'Loop 20 times
        LCD_Data  = szoveg[index]
        gosub I2C_LCD_iras
    NEXT index 'Loop again

    pause 2000
    toggle PIROSLED

    goto main		' Ugras a ciklus elejere, kezdodik minden ujra... 


    I2C_LCD_iras:
        LCD_E = 1              
                           
         LCD_Byte = (LCD_Byte & $0F) | (LCD_Data  & $F0)   ' Fels 4 bit kikldse
         LCD_Byte2 = LCD_Byte & $F8    
         I2CWRITE SDA,SCL,Addr,[LCD_Byte, LCD_Byte2]
                            
         LCD_Byte = (LCD_Byte & $0F) | ((LCD_Data << 4 )& $F0)  ' Als 4 bit kikldse
         LCD_Byte2 = LCD_Byte & $F8
         I2CWRITE SDA,SCL,Addr,[LCD_Byte, LCD_Byte2]    
    return
    
    END				' Itt a progi vege. 
